#include <assert.h>
#include <stdio.h>
#include <unistd.h>

#include <dbus/dbus.h>

int main (int argc, char **argv)
{
  DBusConnection *connection;
  DBusMessage *signal;
  char *dest = NULL;

  connection = dbus_bus_get (DBUS_BUS_SESSION, NULL);
  assert (connection);

  if (argc == 2) {
    dest = argv[1];
  }

  while (1) {
    signal = dbus_message_new_signal ("/", "com.burtonini", "SignalTest");
    if (dest) {
      dbus_message_set_destination (signal, dest);
    }
    puts ("Sending signal");
    dbus_connection_send (connection, signal, NULL);
    dbus_message_unref (signal);

    sleep (1);
  }

  return 0;
}
