#include <assert.h>
#include <stdio.h>

#include <dbus/dbus.h>

static DBusHandlerResult
filter (DBusConnection *connection, DBusMessage *message, void *user_data)
{
  if (dbus_message_is_signal (message, "com.burtonini", "SignalTest")) {
    puts ("Got the signal");
  }
}

int main (int argc, char **argv)
{
  DBusConnection *connection;

  connection = dbus_bus_get (DBUS_BUS_SESSION, NULL);
  assert (connection);

  printf ("My bus address is %s\n", dbus_bus_get_unique_name (connection));

  dbus_bus_add_match (connection,
                      "type='signal', interface='com.burtonini', member='SignalTest'",
                      NULL);

  dbus_connection_add_filter (connection, filter, NULL, NULL);
 
  while (dbus_connection_read_write_dispatch(connection, -1))
     ;

  return 0;
}
